//eroc.h

#ifndef EROFILE_IS_MYLIFE
#define EROFILE_IS_MYLIFE

#define VERSIONSTR "0.100"

//tH[}bgςƂIDς邱
#define ID1 "؂"
#define ID2 "ؗF"
#define IDSIZE 8

#define ERO_NG 0
#define ERO_OK 1

#define STRBUFSIZ 300

typedef unsigned long ulong;
typedef unsigned long crc32_context;
typedef unsigned char uchar;

#pragma pack(push, 1)

typedef struct {
	uchar *filename;//t@CO
	ulong filesize;//t@CTCY
	ulong crc;//t@CCRC32l
	ulong erolevel;//t(ݖgp)
	ulong offset;//擪̃ItZbgʒu(ǂݍݎ̂ݎgp)
} EROFILEINFO;

typedef struct {
	uchar id[8];//tb^ʎq2
	ulong erofilepos;//Gt@C̐擪ʒu
	ulong erofootpos;//tb^̐擪ʒu
	ulong erofilecount;//Gt@C̐
} EROFOOTER;

#pragma pack(pop)

int CreateEroFile(uchar *oyafile, uchar *erofiles[], int filecount);
int DivEroFile(uchar *oyafile, EROFILEINFO *pe, ulong cnt);
int DeleteEroFile(uchar *oyafile, EROFILEINFO *efr);

void * GetEroFileInfo(uchar *file, int *filecount);
int PrintEroFileInfo(EROFILEINFO *efr, ulong cnt);
int FreeEroFileInfo(EROFILEINFO *pe, ulong cnt);

void crc32_starts(crc32_context *c32o);
void crc32_update(crc32_context *c32o, uchar *buf, ulong i);
void crc32_finish(crc32_context *c32o, uchar *digest);
ulong crc32(uchar *file);

void path2fnam(uchar *p, uchar *f);
int input(uchar *mes);
uchar *readfile(uchar *file, ulong *size);
ulong kakidashi(uchar *ofile, uchar *wfile, ulong pos, ulong siz);

#endif
